function Info=InfoCal(PX_Obs, oldcoef, oldlambda, oldPX_Z, r0,...
                             Y, Delta, ZW, Xs, n, m, RZ)

oldbeta=oldcoef(1); oldgamma=oldcoef(2:end); ngamma=length(oldgamma); 
oldLambda=cumsum(oldlambda); 

ntheta=1+size(ZW,2); nn=sum(Delta); nz=length(unique(RZ));

Yind=repmat(Y,1,nn)>=repmat(Y(Delta==1)',n,1);
EXZW=(exp(ZW*oldgamma))*(exp(Xs*oldbeta))';
LambdaEXZW=repmat(oldLambda,1,m).*EXZW;
Exi=repmat(1+r0*Delta,1,m)./(1+r0*LambdaEXZW);

IoldPX_Z=zeros(m, nz); cut=0.0001;
IoldPX_Z(oldPX_Z>cut)=1./oldPX_Z(oldPX_Z>cut);
tempPXZ1=zeros(n, m*nz); Zq=unique(RZ); 
for s=1:1:nz
    tempPXZ1(RZ(:,1)==Zq(s),(s-1)*m+(1:m))=repmat(IoldPX_Z(:,s)', sum(RZ(:,1)==Zq(s)),1);
end

npar=ntheta+nn+m*nz;
EL=zeros(n, npar); ELEL=zeros(npar, npar); 
for k=1:1:m
    Escore=zeros(n, npar); 
    XZW=[repmat(Xs(k),n,1), ZW];
    Escore(:,1:ntheta)=repmat(Delta-Exi(:,k).*LambdaEXZW(:,k),1,ntheta).*XZW;
    Escore(Delta==1, ntheta+(1:nn))=diag(1./oldlambda(Delta==1));
    Escore(:, ntheta+(1:nn))=Escore(:, ntheta+(1:nn))...
        -repmat(Exi(:,k).*EXZW(:,k),1,nn).*Yind;
    Escore(:, ntheta+nn+(k:m:(m*nz)))=tempPXZ1(:, k:m:(m*nz));
    EL=EL+Escore.*repmat(PX_Obs(:,k),1,npar);
    ELEL=ELEL+Escore'*diag(PX_Obs(:,k))*Escore;
end


EL2=zeros(npar, npar);
EL2(ntheta+(1:nn), ntheta+(1:nn))=-diag(1./oldlambda(Delta==1).^2);
for i=1:1:n
    for k=1:1:m
        XZWik=[Xs(k), ZW(i,:)];
        EL2(1:ntheta, 1:ntheta)=EL2(1:ntheta, 1:ntheta)-Exi(i,k)*LambdaEXZW(i,k)*(XZWik'*XZWik)*PX_Obs(i,k);
        EL2(1:ntheta, ntheta+(1:nn))=EL2(1:ntheta, ntheta+(1:nn))-Exi(i,k)*EXZW(i,k)*XZWik'*Yind(i,:)*PX_Obs(i,k);
        ind=ntheta+nn+(k:m:(m*nz));
        EL2(ind, ind)=EL2(ind,ind)-PX_Obs(i,k)*diag(tempPXZ1(i,k:m:(m*nz)).^2);
    end
end
EL2(ntheta+(1:nn), 1:ntheta)=EL2(1:ntheta, ntheta+(1:nn))';

Info=-EL2-(ELEL-EL'*EL);

tempmatrix=zeros(npar, npar-nz*(m-1));
tempmatrix(1:(npar-m*nz), 1:(npar-m*nz))=diag(ones(npar-m*nz,1));
for s=1:1:nz
    tempmatrix(ntheta+nn+(s-1)*m+(1:m), ntheta+nn+(s-1)*(m-1)+(1:(m-1)))=[diag(ones(m-1,1)); -ones(1,m-1)];
end

Info=tempmatrix'*Info*tempmatrix;


temp=(1:1:((m-1)*nz))'; temp=temp(reshape(oldPX_Z(1:(m-1),:), (m-1)*nz,1)<=cut)+ntheta+nn;
temp=setdiff((1:1:size(Info,1))', temp);
Info=Info(temp, temp);
