function [newlambda, newcoef]=Mstep(PX_Obs, oldcoef, oldlambda, r0,...
                             Delta, ZW, Xs, n, m, atrisk)

oldbeta=oldcoef(1); oldgamma=oldcoef(2:end); ngamma=length(oldgamma); 
oldLambda=atrisk'*(oldlambda); 

Im=repmat(1,m,1); EXZW=(exp(ZW*oldgamma))*(exp(Xs*oldbeta))';

temp=repmat(oldLambda,1,m).*EXZW;
Exi=repmat(1+r0*Delta,1,m)./(1+r0*temp);
WW=PX_Obs.*Exi.*EXZW;  SW=WW*Im; SWX=WW*Xs; SWX2=WW*Xs.^2;
denom=rcumsum(SW, atrisk); 
score=[Delta'*(PX_Obs*Xs), Delta'*ZW]';

temp1=rcumsum(SWX, atrisk)./denom;
score(1)=score(1)-Delta'*temp1;
for k=1:1:ngamma
    tempk=rcumsum(SW.*ZW(:,k), atrisk)./denom;
    score(1+k)=score(1+k)-Delta'*tempk;
end

dscore=zeros(1+ngamma, 1+ngamma);
dscore(1,1)=-Delta'*(rcumsum(SWX2, atrisk)./denom)+Delta'*(temp1.^2);
for k=1:1:ngamma
    ZWk=ZW(:,k);
    tempk=rcumsum(SW.*ZWk, atrisk)./denom;
    dscore(1,1+k)=-Delta'*(rcumsum(ZWk.*SWX, atrisk)./denom)...
        +Delta'*(temp1.*tempk);
    dscore(1+k,1)=dscore(1,1+k);
    for s=k:1:ngamma
        ZWs=ZW(:,s);
        temps=(rcumsum(SW.*ZWs, atrisk))./denom;
        dscore(1+k,1+s)=-Delta'*(rcumsum(SW.*ZWk.*ZWs, atrisk)./denom)...
            +Delta'*(tempk.*temps);
        dscore(1+s,1+k)=dscore(1+k,1+s);
    end
end
newcoef=oldcoef-inv(dscore)*score;
newbeta=newcoef(1); newgamma=newcoef(2:end);

newEXZW=(exp(ZW*newgamma))*(exp(Xs*newbeta))';
newlambda=Delta./(rcumsum((PX_Obs.*Exi.*newEXZW)*Im, atrisk));
