library(survival)

tb<-read.table("tb.cohort.txt",header=T)
tb<-within(tb,{
	saRx<- 1 + as.numeric(age.rx>=19) + as.numeric(age.rx>=29)
	age.cat <- 1+ as.numeric(age.out>=40) + as.numeric(age.out>=60)
	dose.cat <- 1 + as.numeric(dose>0) + as.numeric(dose>=2)
	l2d<-log2(dose+1)
})

# Read in case-cohort and stratified (on age.rx) case-cohort datasets
tbcc<-read.table("tb.cascoh.txt", header=T)
tbcc<-within(tbcc,{ saRx<- 1 + as.numeric(age.rx>=19) + as.numeric(age.rx>=29) })
tbsaRxcc<-read.table("tb.saRxcc.txt", header=T)
tbsaRxcc<-within(tbsaRxcc,{ saRx<- 1 + as.numeric(age.rx>=19) + as.numeric(age.rx>=29) })

source("cch.R")

# StratumCohortSizes for sampling via age.rx
stratumCohortSizes<-table(tb$saRx)
stratumCohortSizes
#
fit.ChenLo<-cch(Surv(age.in,age.out,bc)~l2d+age.rx, data=tbcc, subcoh=~subcoh, id=~id, method="ChenLo", cohort.size=1720, robust=T)
summary(fit.ChenLo)
sqrt(diag(fit.ChenLo$phase1var))
sqrt(diag(fit.ChenLo$phase2var))




fit.ChenLo<-cch(Surv(age.in,age.out,bc)~l2d+I(age.rx/10), data=tbcc, subcoh=~subcoh, id=~id, method="ChenLo", cohort.size=1720, robust=T)
summary(fit.ChenLo)
sqrt(diag(fit.ChenLo$phase1var))
sqrt(diag(fit.ChenLo$phase2var))
#
fit.IIborgan<-cch(Surv(age.in,age.out,bc)~l2d+I(age.rx/10), subcoh=~subcoh, id=~X.id, robust=T, stratum=~saRx, cohort.size=stratumCohortSizes, method="II.Borgan", data=tbsaRxcc)
summary(fit.IIborgan)
sqrt(diag(fit.IIborgan$phase1var))
sqrt(diag(fit.IIborgan$phase2var))
