%%%%%%%%%%%%%%%%%%%%%
 IW=0;
load tb.cohort.txt;
id=tb_cohort(:,1);
time=tb_cohort(:,7);
dose=tb_cohort(:,3);
bc=tb_cohort(:,5);
age=tb_cohort(:,6);
agein=tb_cohort(:,8);

load tb.cascoh.txt;
cid=tb_cascoh(:,2);

Y=time; Delta=bc; n=length(Y); 
W=ones(n,1); Z=(age)/10; 
X=log(1+dose)/log(2);
%X=dose;
R=bc;
for k=1:1:length(cid)
    R(id==cid(k))=1;
end
[a,b]=sort(Y);
Y=a; Delta=Delta(b); W=W(b,:); Z=Z(b,:); X=X(b,:); R=R(b,:); agein=agein(b);

ZW=Z; if (IW==1) ZW=[Z,W]; end
nn=sum(Delta); Xs=unique(X(R==1)); m=length(Xs); ncoef=size(ZW,2)+1;
atrisk=(repmat(Y,1,n)<=repmat(Y',n,1)).*(repmat(Y,1,n)>=repmat(agein',n,1));

%%full cohort
beta=coxph(Y,Delta, [X, ZW], 0.001, 1000, atrisk);


%%%%%%%%%%%%%%%%%%%%% assuming X independent of Z%%%%%%%%%%%%%%%%%%%%%%%%%%
q=1; r0=0;
KZZ=zeros(n,1)+1; RZ=ones(n,1);
oldcoef=zeros(ncoef,1); oldPX_Z=repmat(1/m,m,q);
oldlambda=zeros(n,1); oldlambda(Delta==1)=1/nn;
error=1; iter=0;
while(error>0.001 & iter<1000)
    [PX_Obs, newPX_Z]=weightfun(oldPX_Z, oldlambda, oldcoef,...
        Delta, X, ZW, R, Xs, n, m, r0, KZZ, atrisk);
    [newlambda, newcoef]=Mstep(PX_Obs, oldcoef, oldlambda, r0, ...
        Delta, ZW, Xs, n, m, atrisk);
    error=max([sum(abs(oldcoef-newcoef)); sum(abs(oldlambda-newlambda));...
        (sum(abs(newPX_Z-oldPX_Z)))']);
    iter=iter+1;
    %[iter, error]
    [[oldcoef, newcoef]]
    oldcoef=newcoef; oldlambda=newlambda; oldPX_Z=newPX_Z;
end
[iter, error]
hn=5/sqrt(n);
cov=covest(oldcoef, oldlambda, oldPX_Z, Y, Delta, X, ZW, R, Xs, n, m, ...
    KZZ, hn, r0, atrisk);
parest2=newcoef;
sdest2=(sqrt(diag(cov)));
Info=InfoCal(PX_Obs, oldcoef, oldlambda, oldPX_Z, r0,...
                             Y, Delta, ZW, Xs, n, m, RZ);
cov=inv(Info); cov=cov(1:ncoef, 1:ncoef); sdest1=sqrt(diag(cov));

[parest2, sdest1, parest2./sdest1, 2*(1-normcdf(abs(parest2./sdest1),0,1)), ...
    sdest2, parest2./sdest2, 2*(1-normcdf(abs(parest2./sdest2),0,1))]


templik=loglikfun(oldPX_Z, oldlambda, oldcoef, Delta, ...
                        X, ZW, R, Xs,  n, m, KZZ, r0, atrisk)





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%X depends on Z%%%%%%%%%%%%%%
 r0=0;

 
% assuming X depends on Z
RZ=round(ZW(:,1)*10);
RZs=unique(RZ); q=length(RZs);
KZZ=zeros(n,1);
for k=1:1:q
    KZZ(abs(RZ-RZs(k))==0)=k;
end

oldcoef=zeros(ncoef,1); oldPX_Z=repmat(1/m,m,q);
oldlambda=zeros(n,1); oldlambda(Delta==1)=1/nn;
error=1; iter=0;
while(error>0.001 & iter<5000)
    [PX_Obs, newPX_Z]=weightfun(oldPX_Z, oldlambda, oldcoef,...
        Delta, X, ZW, R, Xs, n, m, r0, KZZ, atrisk);
    [newlambda, newcoef]=Mstep(PX_Obs, oldcoef, oldlambda, r0, ...
        Delta, ZW, Xs, n, m, atrisk);
    error=max([sum(abs(oldcoef-newcoef)); sum(abs(oldlambda-newlambda));...
        (sum(abs(newPX_Z-oldPX_Z)))']);
    iter=iter+1;
    %[iter, error]
    %[[oldcoef, newcoef]]
    oldcoef=newcoef; oldlambda=newlambda; oldPX_Z=newPX_Z;
end
[iter, error]

hn=5/sqrt(n);
cov=covest(oldcoef, oldlambda, oldPX_Z, Y, Delta, X, ZW, R, Xs, n, m, ...
    KZZ, hn, r0, atrisk);
sdest1=(sqrt(diag(cov)));
parest1=newcoef;
Info=InfoCal(PX_Obs, oldcoef, oldlambda, oldPX_Z, r0,...
                             Y, Delta, ZW, Xs, n, m, RZ);
cov=inv(Info); cov=cov(1:ncoef, 1:ncoef); sdest2=sqrt(diag(cov));

[parest1, sdest1, parest1./sdest1, 2*(1-normcdf(abs(parest1./sdest1),0,1)), ...
    sdest2, parest1./sdest2, 2*(1-normcdf(abs(parest1./sdest2),0,1))]

