function [PX_Obs, newPX_Z]=weightfun(oldPX_Z, oldlambda, oldcoef, ...
                                Delta, X, ZW, R, Xs, n, m, r0, KZZ, atrisk)

oldbeta=oldcoef(1); oldgamma=oldcoef(2:end); 
oldLambda=atrisk'*(oldlambda);

q=size(oldPX_Z,2);

PX_Obs=zeros(n,m); denom=zeros(n,1);
for k=1:1:m
    PX_Obs(X==Xs(k) & R==1, k)=1;
    EXZW=exp(ZW(R==0,:)*oldgamma+Xs(k)*oldbeta);
    LambdaEXZ=oldLambda(R==0).*EXZW;
    if (r0>0)
       G=log(1+r0*LambdaEXZ)/r0;
    else
       G=LambdaEXZ;
    end
    dG=1./(1+r0*LambdaEXZ);
    PY_ZWX=exp(Delta(R==0)*(Xs(k)*oldbeta)+Delta(R==0).*log(dG)-G);
    PX_Obs(R==0,k)=oldPX_Z(k, KZZ(R==0))'.*PY_ZWX;  
end
PX_Obs(R==0,:)=PX_Obs(R==0,:)./repmat(PX_Obs(R==0,:)*ones(m,1),1,m);

newPX_Z=zeros(m,q);
for l=1:1:q
    newPX_Z(:,l)=(sum(PX_Obs(KZZ==l,:)))';
    newPX_Z(:,l)=newPX_Z(:,l)/sum(newPX_Z(:,l));
end
